      SUBROUTINE OFF3PT(X1,Y1,X2,Y2,X3,Y3,STH1,CTH1,DELX,DELY)
C
C   THIS SUBROUTINE CALCULATES (DELX,DELY) OFFSET FROM (X2,Y2), GIVEN
C     3 PTS & THE OFFSET DELTA DISTANCE DOFF (IN PLOT UNITS).
C     ALSO RETURNED ARE STH1 & CTH1, THE SIN & COS OF THE ANGLE LINE
C     SEGMENT 1 MAKES WITH THE PLOT AXES.
C
      COMMON /PXZ99/
     1FSCAL,IPLTR,IPLTX,INCMT,FMTOL,FMTL2,RXYRS,RYXRS,
     2XRASP,YRASP,XRASX,YRASX,XRSPP,YRSPP,IXLOG,IYLOG,
     3RXMIN,RXMAX,RYMIN,RYMAX,XSCLE,YSCLE,XOFFS,YOFFS,
     4IOBUF(128),NCCNT,NCCMX,NCOUT,NCMAX,NWOUT,NCMUL(6),
     5MASKA,MASKS,LUOUT,ICSTR(20),NCSTR,IDECT(10),ISYMN,
     6ISYMP,LZERO,IDWRK(16),NXYRS,NBLKO,
     7IXRAS(50),IYRAS(50),IPENC(50),NXYSI,NCALS,
     8IDASH(8),DASHT(64),DASHL(16),RDASH(8),DASHX(64),
     9NDASH(8),ICHRL,NCHRI,NCHRO,NLINI,NLINO,LUTTY,LUERR,
     1IERCK(90),MAXER,IXAXC,IYAXC,IAXTY,IHYPH,IZROT,
     2DOFF,XRASPI,YRASPI,JCOL
C
      DATA TOL/.1/
C***********************************************************************
      DY=Y2-Y1
      DX=X2-X1
      R=SQRT(DX*DX+DY*DY)
      STH1=DY/R
      CTH1=DX/R
      TH1=ATAN2(DY*YRASPI,DX*XRASPI)
      TH2=ATAN2((Y3-Y2)*YRASPI,(X3-X2)*XRASPI)
C***********************************************************************
      TH=0.5*(TH1-TH2)
      CTH=COS(TH)
C
C   NOTE:  TOL MUST BE IN PLOT UNITS.  (E.G. INCHES)
C
      IF(ABS(CTH).GT.TOL) GO TO 10
C
C   HERE COS(TH) = 0.0; LINE RETRACES ITSELF.  CALC PERPENDICULAR.
C
      CALL RTOFF(X1,Y1,X2,Y2,DELX,DELY)
      RETURN
   10 P=DOFF/CTH
      THP=0.5*(TH2+TH1)
      DELY=P*COS(THP)*YRASP
      DELX=-P*SIN(THP)*XRASP
      RETURN
      END

